diff -r f6ef988fda71 trytond/model/model.py
--- a/trytond/model/model.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/model/model.py	Sun Sep 23 17:30:03 2012 +0200
@@ -3,154 +3,152 @@
 
 import copy
 import collections
+import warnings
+
 from trytond.model import fields
 from trytond.error import WarningErrorMixin
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 from trytond.pyson import PYSONEncoder
 from trytond.transaction import Transaction
 from trytond.url import URLMixin
+from trytond.rpc import RPC
+
+__all__ = ['Model']
+
+
+class ModelMeta(PoolMeta):
+
+    def __getattr__(self, name):
+        pool = Pool()
+        for model_name, _ in self._inherits.iteritems():
+            Model = pool.get(model_name)
+            if isinstance(getattr(Model, name, None),
+                    collections.Callable):
+                meth = getattr(Model, name)
+                if not hasattr(meth, 'im_self') or meth.im_self:
+                    # Return classmethod bounded to inherited class
+                    return meth
+                else:
+                    for cls in Model.__mro__:
+                        if name in cls.__dict__:
+                            # Return a method bounded to current class
+                            return cls.__dict__[name].__get__(None, self)
+        raise AttributeError("'%s' Model has no attribute '%s'"
+            % (self.__name__, name))
 
 
 class Model(WarningErrorMixin, URLMixin):
     """
     Define a model in Tryton.
     """
-    _name = None
+    __metaclass__ = ModelMeta
     _inherits = {}
-    _description = ''
-    __columns = None
-    __defaults = None
     _rec_name = 'name'
 
     id = fields.Integer('ID', readonly=True)
 
-    def _reset_columns(self):
-        self.__columns = None
-        self.__defaults = None
+    @classmethod
+    def __setup__(cls):
+        cls.__rpc__ = {
+            'default_get': RPC(),
+            'fields_get': RPC(),
+            'on_change_with': RPC(instantiate=0),
+            }
+        cls._error_messages = {}
 
-    def _getcolumns(self):
-        if self.__columns:
-            return self.__columns
-        res = {}
-        for attr in dir(self):
+        # Copy fields
+        for attr in dir(cls):
             if attr.startswith('_'):
                 continue
-            if isinstance(getattr(self, attr), fields.Field):
-                res[attr] = getattr(self, attr)
-        self.__columns = res
-        return res
+            if isinstance(getattr(cls, attr), fields.Field):
+                setattr(cls, attr, copy.deepcopy(getattr(cls, attr)))
 
-    #replace by _fields
-    _columns = property(fget=_getcolumns)
+    @classmethod
+    def __post_setup__(cls):
+        pool = Pool()
 
-    def _reset_defaults(self):
-        self.__defaults = None
+        # Set _fields
+        cls._fields = {}
+        for attr in dir(cls):
+            if attr.startswith('_'):
+                continue
+            if isinstance(getattr(cls, attr), fields.Field):
+                cls._fields[attr] = getattr(cls, attr)
 
-    def _getdefaults(self):
-        if self.__defaults:
-            return self.__defaults
-        res = {}
-        fields_names = self._columns.keys()
-        fields_names += self._inherit_fields.keys()
+        # Set _inherit_fields
+        cls._inherit_fields = {}
+        for model_name in cls._inherits:
+            Model = pool.get(model_name)
+            cls._inherit_fields.update(Model._inherit_fields)
+            for field_name in Model._fields.keys():
+                cls._inherit_fields[field_name] = (model_name,
+                    cls._inherits[model_name],
+                    Model._fields[field_name])
+            for field_name in Model._inherit_fields.keys():
+                cls._inherit_fields[field_name] = (model_name,
+                    cls._inherits[model_name],
+                    Model._inherit_fields[field_name][2])
+        # Update models that uses this one in _inherits
+        for _, Model in pool.iterobject():
+            if cls.__name__ in Model._inherits:
+                Model.__post_setup__()
+
+        # Set _defaults
+        cls._defaults = {}
+        fields_names = cls._fields.keys()
+        fields_names += cls._inherit_fields.keys()
         for field_name in fields_names:
-            default_method = getattr(self, 'default_%s' % field_name, False)
+            default_method = getattr(cls, 'default_%s' % field_name, False)
+            if not default_method and field_name in cls._inherit_fields:
+                icls = pool.get(cls._inherit_fields[field_name][0])
+                default_method = getattr(icls, 'default_%s' % field_name,
+                    False)
             if isinstance(default_method, collections.Callable):
-                res[field_name] = default_method
-        self.__defaults = res
-        return res
+                cls._defaults[field_name] = default_method
 
-    _defaults = property(fget=_getdefaults)
+        for k in cls._defaults:
+            assert (k in cls._fields) or (k in cls._inherit_fields), \
+                'Default function defined in %s but field %s does not exist!' \
+                % (cls.__name__, k,)
 
-    def __new__(cls):
-        Pool.register(cls, type='model')
-
-    def __init__(self):
-        super(Model, self).__init__()
-        self._rpc = {
-            'default_get': False,
-            'fields_get': False,
-            'on_change_with': False,
-        }
-        self._inherit_fields = []
-        self._error_messages = {}
-        # reinit the cache on _columns and _defaults
-        self.__columns = None
-        self.__defaults = None
-
-        if not self._description:
-            self._description = self._name
-
-        self._inherits_reload()
-        for k in self._defaults:
-            assert (k in self._columns) or (k in self._inherit_fields), \
-            'Default function defined in %s but field %s does not exist!' % \
-                (self._name, k,)
-        self._update_rpc()
-
-    def _update_rpc(self):
-        for field_name in self._columns.keys() + self._inherit_fields.keys():
-            if field_name in self._columns:
-                field = self._columns[field_name]
+        # Update __rpc__
+        for field_name in cls._fields.keys() + cls._inherit_fields.keys():
+            if field_name in cls._fields:
+                field = cls._fields[field_name]
             else:
-                field = self._inherit_fields[field_name][2]
+                field = cls._inherit_fields[field_name][2]
             if isinstance(field, (fields.Selection, fields.Reference)) \
                     and not isinstance(field.selection, (list, tuple)) \
-                    and field.selection not in self._rpc:
-                self._rpc[field.selection] = False
+                    and field.selection not in cls.__rpc__:
+                cls.__rpc__[field.selection] = RPC()
 
             for attribute in ('on_change', 'on_change_with', 'autocomplete'):
                 function_name = '%s_%s' % (attribute, field_name)
-                if (getattr(field, attribute, False)
-                         and isinstance(getattr(self, function_name, False),
-                             collections.Callable)):
-                    self._rpc.setdefault(function_name, False)
+                if getattr(field, attribute, False):
+                    cls.__rpc__.setdefault(function_name, RPC(instantiate=0))
 
-    def __getattr__(self, name):
-        pool = Pool()
-        # Search if a function exists in inherits parents
-        for model_name, field_name in self._inherits.iteritems():
-            model_obj = pool.get(model_name)
-            if (hasattr(model_obj, name)
-                    and isinstance(getattr(model_obj, name),
-                        collections.Callable)):
-                return getattr(model_obj, name)
-        raise AttributeError(name)
+        # Set name to fields
+        for name, field in cls._fields.iteritems():
+            if field.name is None:
+                field.name = name
+            else:
+                assert field.name == name, (
+                    'Duplicate fields on %s: %s, %s'
+                    % (cls, field.name, name))
 
-    def _inherits_reload(self):
-        """
-        Reconstruct _inherit_fields
-        """
-        res = {}
-        pool = Pool()
-        for model in self._inherits:
-            res.update(pool.get(model)._inherit_fields)
-            for field_name in pool.get(model)._columns.keys():
-                res[field_name] = (model, self._inherits[model],
-                        pool.get(model)._columns[field_name])
-            for field_name in pool.get(model)._inherit_fields.keys():
-                res[field_name] = (model, self._inherits[model],
-                        pool.get(model)._inherit_fields[field_name][2])
-        self._inherit_fields = res
-        self._reset_columns()
-        self._update_rpc()
-        # Update objects that uses this one to update their _inherits fields
-        for obj_name in pool.object_name_list():
-            obj = pool.get(obj_name)
-            if self._name in obj._inherits:
-                obj._inherits_reload()
-
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         """
         Add model in ir.model and ir.model.field.
-
-        :param module_name: the module name
         """
-        translation_obj = Pool().get('ir.translation')
+        pool = Pool()
+        Translation = pool.get('ir.translation')
+        Property = pool.get('ir.property')
 
         cursor = Transaction().cursor
         # Add model in ir_model
         cursor.execute("SELECT id FROM ir_model WHERE model = %s",
-                (self._name,))
+                (cls.__name__,))
         model_id = None
         if cursor.rowcount == -1 or cursor.rowcount is None:
             data = cursor.fetchone()
@@ -159,28 +157,31 @@
         elif cursor.rowcount != 0:
             model_id, = cursor.fetchone()
         if not model_id:
-            cursor.execute("INSERT INTO ir_model " \
-                    "(model, name, info, module) VALUES (%s, %s, %s, %s)",
-                    (self._name, self._description, self.__doc__,
-                        module_name))
+            cursor.execute("INSERT INTO ir_model "
+                "(model, name, info, module) VALUES (%s, %s, %s, %s)",
+                (cls.__name__, cls.__doc__.splitlines()[0], cls.__doc__,
+                    module_name))
+            Property._models_get_cache.clear()
             cursor.execute("SELECT id FROM ir_model WHERE model = %s",
-                    (self._name,))
+                    (cls.__name__,))
             (model_id,) = cursor.fetchone()
-        else:
-            cursor.execute('UPDATE ir_model ' \
-                    'SET name = %s, ' \
-                        'info = %s ' \
-                    'WHERE id = %s',
-                    (self._description, self.__doc__, model_id))
+        elif cls.__doc__:
+            cursor.execute('UPDATE ir_model '
+                'SET name = %s, '
+                    'info = %s '
+                'WHERE id = %s',
+                (cls.__doc__.splitlines()[0], cls.__doc__, model_id))
 
         # Update translation of model
-        for name, src in [(self._name + ',name', self._description)]:
-            cursor.execute('SELECT id FROM ir_translation '
-                'WHERE lang = %s '
-                    'AND type = %s '
-                    'AND name = %s '
-                    'AND (res_id IS NULL OR res_id = %s)',
-                ('en_US', 'model', name, 0))
+        if cls.__doc__:
+            name = cls.__name__ + ',name'
+            src = cls.__doc__.splitlines()[0]
+            cursor.execute('SELECT id FROM ir_translation ' \
+                    'WHERE lang = %s ' \
+                        'AND type = %s ' \
+                        'AND name = %s ' \
+                        'AND (res_id IS NULL OR res_id = %s)',
+                    ('en_US', 'model', name, 0))
             trans_id = None
             if cursor.rowcount == -1 or cursor.rowcount is None:
                 data = cursor.fetchone()
@@ -188,7 +189,7 @@
                     trans_id, = data
             elif cursor.rowcount != 0:
                 trans_id, = cursor.fetchone()
-            src_md5 = translation_obj.get_src_md5(src)
+            src_md5 = Translation.get_src_md5(src)
             if trans_id is None:
                 cursor.execute('INSERT INTO ir_translation '
                     '(name, lang, type, src, src_md5, value, module, fuzzy) '
@@ -209,21 +210,21 @@
                 'FROM ir_model_field AS f, ir_model AS m ' \
                 'WHERE f.model = m.id ' \
                     'AND m.model = %s ',
-                        (self._name,))
+                        (cls.__name__,))
         model_fields = {}
         for field in cursor.dictfetchall():
             model_fields[field['name']] = field
 
         # Prefetch field translations
-        if self._columns:
+        if cls._fields:
             cursor.execute('SELECT id, name, src, type FROM ir_translation ' \
                     'WHERE lang = %s ' \
                         'AND type IN (%s, %s, %s) ' \
                         'AND name IN ' \
-                            '(' + ','.join(('%s',) * len(self._columns)) + ')',
+                            '(' + ','.join(('%s',) * len(cls._fields)) + ')',
                             ('en_US', 'field', 'help', 'selection') + \
-                                    tuple([self._name + ',' + x \
-                                        for x in self._columns]))
+                                    tuple([cls.__name__ + ',' + x \
+                                        for x in cls._fields]))
         trans_fields = {}
         trans_help = {}
         trans_selection = {}
@@ -236,8 +237,8 @@
                 trans_selection.setdefault(trans['name'], {})
                 trans_selection[trans['name']][trans['src']] = trans
 
-        for field_name in self._columns:
-            field = self._columns[field_name]
+        for field_name in cls._fields:
+            field = cls._fields[field_name]
             relation = ''
             if hasattr(field, 'model_name'):
                 relation = field.model_name
@@ -262,8 +263,8 @@
                         'WHERE id = %s ',
                         (field.string, field._type, relation,
                             field.help, model_fields[field_name]['id']))
-            trans_name = self._name + ',' + field_name
-            string_md5 = translation_obj.get_src_md5(field.string)
+            trans_name = cls.__name__ + ',' + field_name
+            string_md5 = Translation.get_src_md5(field.string)
             if trans_name not in trans_fields:
                 cursor.execute('INSERT INTO ir_translation '
                     '(name, lang, type, src, src_md5, value, module, fuzzy) '
@@ -275,7 +276,7 @@
                     'SET src = %s, src_md5 = %s '
                     'WHERE id = %s ',
                     (field.string, string_md5, trans_fields[trans_name]['id']))
-            help_md5 = translation_obj.get_src_md5(field.help)
+            help_md5 = Translation.get_src_md5(field.help)
             if trans_name not in trans_help:
                 if field.help:
                     cursor.execute('INSERT INTO ir_translation '
@@ -297,7 +298,7 @@
                 for (_, val) in field.selection:
                     if trans_name not in trans_selection \
                             or val not in trans_selection[trans_name]:
-                        val_md5 = translation_obj.get_src_md5(val)
+                        val_md5 = Translation.get_src_md5(val)
                         cursor.execute('INSERT INTO ir_translation '
                             '(name, lang, type, src, src_md5, value, module, '
                                 'fuzzy) '
@@ -307,7 +308,7 @@
         # Clean ir_model_field from field that are no more existing.
         for field_name in model_fields:
             if model_fields[field_name]['module'] == module_name \
-                    and field_name not in self._columns:
+                    and field_name not in cls._fields:
                 #XXX This delete field even when it is defined later
                 # in the module
                 cursor.execute('DELETE FROM ir_model_field '\
@@ -319,145 +320,135 @@
                 'WHERE lang = %s ' \
                     'AND type = %s ' \
                     'AND name = %s',
-                ('en_US', 'error', self._name))
+                ('en_US', 'error', cls.__name__))
         trans_error = {}
         for trans in cursor.dictfetchall():
             trans_error[trans['src']] = trans
 
-        errors = self._get_error_messages()
+        errors = cls._get_error_messages()
         for error in set(errors):
             if error not in trans_error:
-                error_md5 = translation_obj.get_src_md5(error)
+                error_md5 = Translation.get_src_md5(error)
                 cursor.execute('INSERT INTO ir_translation '
                     '(name, lang, type, src, src_md5, value, module, fuzzy) '
                     'VALUES (%s, %s, %s, %s, %s, %s, %s, %s)',
-                    (self._name, 'en_US', 'error', error, error_md5, '',
+                    (cls.__name__, 'en_US', 'error', error, error_md5, '',
                         module_name, False))
 
-    def _get_error_messages(self):
-        return self._error_messages.values()
+    @classmethod
+    def _get_error_messages(cls):
+        return cls._error_messages.values()
 
-    def default_get(self, fields_names, with_rec_name=True):
+    @classmethod
+    def default_get(cls, fields_names, with_rec_name=True):
         '''
         Return a dict with the default values for each field in fields_names.
-
-        :param fields_names: a list of fields names
-        :param with_rec_name: a boolean to add rec_name value
-        :return: a dictionary with field name as key
-            and default value as value
+        If with_rec_name is True, rec_name will be added.
         '''
         pool = Pool()
-        property_obj = pool.get('ir.property')
+        Property = pool.get('ir.property')
         value = {}
 
         # get the default values defined in the object
         for field_name in fields_names:
-            if field_name in self._defaults:
-                value[field_name] = self._defaults[field_name]()
-            if field_name in self._columns:
-                field = self._columns[field_name]
+            if field_name in cls._defaults:
+                value[field_name] = cls._defaults[field_name]()
+            if field_name in cls._fields:
+                field = cls._fields[field_name]
             else:
-                field = self._inherit_fields[field_name][2]
+                field = cls._inherit_fields[field_name][2]
             if (field._type == 'boolean'
                     and not field_name in value):
                 value[field_name] = False
             if isinstance(field, fields.Property):
-                value[field_name] = property_obj.get(field_name, self._name)
+                value[field_name] = Property.get(field_name, cls.__name__)
             if (with_rec_name
                     and field._type in ('many2one',)
                     and value.get(field_name)):
-                obj = pool.get(field.model_name)
-                if 'rec_name' in obj._columns:
-                    value[field_name + '.rec_name'] = obj.browse(
+                Target = pool.get(field.model_name)
+                if 'rec_name' in Target._fields:
+                    value[field_name + '.rec_name'] = Target(
                         value[field_name]).rec_name
 
-        value = self._default_on_change(value)
+        value = cls._default_on_change(value)
         if not with_rec_name:
             for field in value.keys():
                 if field.endswith('.rec_name'):
                     del value[field]
         return value
 
-    def _default_on_change(self, value):
+    @classmethod
+    def _default_on_change(cls, value):
         """
         Call on_change function for the default value
         and return new default value
-
-        :param value: a dictionnary with the default value
-        :return: a new dictionnary of default value
         """
         pool = Pool()
         res = value.copy()
         val = {}
-        for i in self._inherits.keys():
+        for i in cls._inherits.keys():
             val.update(pool.get(i)._default_on_change(value))
         for field in value.keys():
-            if field in self._columns:
-                if self._columns[field].on_change:
-                    args = {}
-                    for arg in self._columns[field].on_change:
-                        args[arg] = value.get(arg, None)
-                        if arg in self._columns \
-                                and self._columns[arg]._type == 'many2one':
-                            if isinstance(args[arg], (list, tuple)):
-                                args[arg] = args[arg][0]
-                    val.update(getattr(self, 'on_change_' + field)(args))
-                if self._columns[field]._type in ('one2many',):
-                    obj = pool.get(self._columns[field].model_name)
+            if field in cls._fields:
+                if cls._fields[field].on_change:
+                    inst = cls()
+                    for fname in cls._fields[field].on_change:
+                        setattr(inst, fname, value.get(fname))
+                    val.update(getattr(inst, 'on_change_' + field)())
+                if cls._fields[field]._type in ('one2many',):
+                    Target = pool.get(cls._fields[field].model_name)
                     for val2 in res[field]:
-                        val2.update(obj._default_on_change(val2))
+                        val2.update(Target._default_on_change(val2))
         res.update(val)
         return res
 
-    def fields_get(self, fields_names=None):
+    @classmethod
+    def fields_get(cls, fields_names=None):
         """
         Return the definition of each field on the model.
-
-        :param fields_names: a list of field names or None for all fields
-        :return: a dictionary with field name as key and definition as value
         """
         res = {}
         pool = Pool()
-        translation_obj = pool.get('ir.translation')
-        field_access_obj = pool.get('ir.model.field.access')
+        Translation = pool.get('ir.translation')
+        FieldAccess = pool.get('ir.model.field.access')
 
-        for parent in self._inherits:
+        for parent in cls._inherits:
             res.update(pool.get(parent).fields_get(fields_names))
 
         #Add translation to cache
         language = Transaction().language
         trans_args = []
-        for field in (x for x in self._columns.keys()
+        for field in (x for x in cls._fields.keys()
                 if ((not fields_names) or x in fields_names)):
-            trans_args.append((self._name + ',' + field, 'field', language,
+            trans_args.append((cls.__name__ + ',' + field, 'field', language,
                 None))
-            trans_args.append((self._name + ',' + field, 'help', language,
+            trans_args.append((cls.__name__ + ',' + field, 'help', language,
                 None))
-            if hasattr(self._columns[field], 'selection'):
-                if isinstance(self._columns[field].selection, (tuple, list)) \
-                        and ((hasattr(self._columns[field],
+            if hasattr(cls._fields[field], 'selection'):
+                if isinstance(cls._fields[field].selection, (tuple, list)) \
+                        and ((hasattr(cls._fields[field],
                             'translate_selection') \
-                            and self._columns[field].translate_selection) \
-                            or not hasattr(self._columns[field],
+                            and cls._fields[field].translate_selection) \
+                            or not hasattr(cls._fields[field],
                                 'translate_selection')):
-                    sel = self._columns[field].selection
+                    sel = cls._fields[field].selection
                     for (key, val) in sel:
-                        trans_args.append((self._name + ',' + field,
+                        trans_args.append((cls.__name__ + ',' + field,
                             'selection', language, val))
-        translation_obj.get_sources(trans_args)
+        Translation.get_sources(trans_args)
 
         encoder = PYSONEncoder()
 
-        fwrite_accesses = field_access_obj.check(self._name, fields_names or
-                self._columns.keys(), 'write', access=True)
-        fcreate_accesses = field_access_obj.check(self._name, fields_names or
-            self._columns.keys(), 'create', access=True)
-        fdelete_accesses = field_access_obj.check(self._name, fields_names or
-            self._columns.keys(), 'delete', access=True)
-        for field in (x for x in self._columns.keys()
+        fwrite_accesses = FieldAccess.check(cls.__name__, fields_names or
+            cls._fields.keys(), 'write', access=True)
+        fcreate_accesses = FieldAccess.check(cls.__name__, fields_names or
+            cls._fields.keys(), 'create', access=True)
+        fdelete_accesses = FieldAccess.check(cls.__name__, fields_names or
+            cls._fields.keys(), 'delete', access=True)
+        for field in (x for x in cls._fields.keys()
                 if ((not fields_names) or x in fields_names)):
             res[field] = {
-                'type': self._columns[field]._type,
+                'type': cls._fields[field]._type,
                 'name': field,
                 }
             for arg in (
@@ -478,8 +469,8 @@
                     'loading',
                     'filename',
                     ):
-                if getattr(self._columns[field], arg, None) is not None:
-                    res[field][arg] = copy.copy(getattr(self._columns[field],
+                if getattr(cls._fields[field], arg, None) is not None:
+                    res[field][arg] = copy.copy(getattr(cls._fields[field],
                         arg))
             if not fwrite_accesses.get(field, True):
                 res[field]['readonly'] = True
